function [Tour,Cost, time] = tsp_opt(G);
   [t0, u0, s0] = cputime ();
   n = size(G,1);
   [Tour,Cost] = hamilton_opt(G,[1],0,2:n);
   [t1, u1, s1] = cputime ();
   elapsed_total_time = t1-t0;
   elapsed_user_time = u1-u0;
   time = u1-u0;
   elapsed_system_time = s1-s0;
end

function [Tour,Cost] = hamilton_opt(G, Visited, CostSoFar, ToVisit)
   if length(ToVisit) == 0
      Tour = Visited;
      Cost = CostSoFar + G(Visited(end), Visited(1));
   else
      Cost = Inf;
      Tour = [];
      for i = 1:length(ToVisit)
         last = Visited(end);
         next = ToVisit(i);
         NewVisited = [Visited,next];
         NewCostSoFar = CostSoFar + G(last, next);
         NewToVisit = [ToVisit(1:i-1),ToVisit(i+1:end)];
         [T,C] = hamilton_opt(G, NewVisited, NewCostSoFar, NewToVisit);
         if C < Cost
            Tour = T; 
            Cost = C;
         end 
      end
   end
end